#include "Browser.h"



void Browser::handleRequest(Request* request)
{
		// dispatch to appropriate handle...
	handleSelectItem(request);
}

void Browser::handleSelectItem(Request* req)
{
	SelectItemRequest* request = (SelectItemRequest*) req;
	if (editor->hasDocChanged()) {
		// warning dialog
	}
	else if (!FileSystem::Instance()->isAvailable(request->item->getName())) {
		forwardRequest(request);
	}
	else {
		selectItem(request);
	}
}

void Browser::selectItem(SelectItemRequest* request)
{
	lister->selectItem(request);
	Document* doc = FileSystem::Instance()->LoadDocument(request->item->getName());
	editor->setDocument(doc);
	cout << "new item selected\n";
}
	
void Browser::update(Tool* subtool, Event* event)
{
		// dispatch to appropriate update...
	checkOriginalUpdated();
}

void Browser::checkOriginalUpdated()
{
	cout << "working copy was written back\n";
}
	
Lister* Browser::getLister()
{
	return lister;
}

Lister* Browser::newLister()
{
	return new Lister;
}

void Browser::setLister(Lister* newLister)
{
	delete lister;
	lister = newLister;
	lister->setParent(this);
}

Editor* Browser::getEditor()
{
	return editor;
}

Editor* Browser::newEditor()
{
	return new Editor;
}

void Browser::setEditor(Editor* newEditor)
{
	delete editor;
	editor = newEditor;
	editor->setParent(this);
}
		
Browser::Browser()
{
	lister = 0;
	editor = 0;
}

Browser::~Browser()
{
	delete lister;
	delete editor;
}

