#ifndef _Browser_h
#define _Browser_h

#include <iostream.h>

#include "Editor.h"
#include "Lister.h"

#include "CompTool.h"



class Browser : public CompTool 
{
public:
		// Handler role
	virtual void handleRequest(Request* request);
	virtual void handleSelectItem(Request* req);
	virtual void selectItem(SelectItemRequest* request);
	
		// Observer role
	virtual void update(Tool* subtool, Event* event);
	virtual void checkOriginalUpdated();
	
		// basic stuff
	virtual Lister* getLister();
	virtual Lister* newLister();
	virtual void setLister(Lister* newLister);
	virtual Editor* getEditor();
	virtual Editor* newEditor();
	virtual void setEditor(Editor* newEditor);
		
		// ctor, dtor, meta
	Browser();
	virtual ~Browser();

protected:
	Lister* lister;
	Editor* editor;
};

#endif
