#ifndef _Lister_h
#define _Lister_h

#include "Tool.h"

class SelectItemRequest;



class Lister : public Tool 
{
public:
		// hierarchy integration
	virtual Directory* getDirectory();
	virtual void setDirectory(Directory* newDir);
	virtual DirItem* getCurrentItem();
	virtual void selectItem(DirItem* newItem);
	
		// user interaction delegated up the hierarchy
	virtual void selectItemRequested(int index);
	virtual void selectItem(SelectItemRequest* request);
	
		// user interaction handled locally
	virtual void changeSortOrderRequested(int index);
	virtual void changeSortOrder(int index);

		// events announced by instances of this class
	class SelectedItemChangedEvent : public Event {};
	class SortOrderChangedEvent : public Event {};
		
		// ctor, dtor, meta
	Lister();
	virtual ~Lister();

protected:
	DirItem* currentItem;
	Directory* directory;
};



class SelectItemRequest : public Request
{
public:
	SelectItemRequest(DirItem* newItem, int newIndex)
	{ item = newItem; index = newIndex; }
	DirItem* item;
	int index;
};



#endif
