#ifndef _Roles_h
#define _Roles_h

#include "Standard.h"



class Observable;
class Observer;

class Observable
{
public:
	virtual void notify(Event*) =0;
	virtual void attach(Observer*) =0;
	virtual void detach(Observer*) =0;
};

class Observer
{
public:
	virtual void update(Observable*, Event*) =0;
};



class Handler;
class Successor;

class Handler
{
public:
	virtual Successor* getSuccessor() =0;
	virtual void setSuccessor() =0;
	virtual void forwardRequest(Request*) =0;
};

class Successor
{
public:
	virtual void handleRequest(Request*) =0;
};



class Component;
class Composite;

class Component
{
public:
	virtual Composite* getParent() =0;
	virtual void setParent(Component*) =0;
	virtual void asComposite() =0;	
};

class Composite
{
public:
	virtual void insert(Component*) =0;
	virtual void remove(Component*) =0;
};



#endif
